import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _extends from 'babel-runtime/helpers/extends';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import React from 'react';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import cx from 'classnames';
import * as enhancers from '../enhancers';

var enhancersArray = _Object$keys(enhancers).map(function (key) {
  return enhancers[key];
});

var propTypes = enhancersArray.reduce(function (memo, _ref) {
  var propTypes = _ref.propTypes;

  if (propTypes) memo = _extends({}, memo, propTypes);
}, {
  onRef: PropTypes.func,
  is: PropTypes.oneOfType([PropTypes.string, PropTypes.element, PropTypes.func])
});

var parseProps = function parseProps(props) {
  return enhancersArray.reduce(function (props, _ref2) {
    var parseProps = _ref2.parseProps;

    if (parseProps) props = parseProps(props);
    return props;
  }, props);
};

var n = 'ui-lib-box';

// Add these styles globally until glamor properly supports &:matches

css.global('article.' + n + ', aside.' + n + ', details.' + n + ', figcaption.' + n + ', figure.' + n + ', footer.' + n + ', header.' + n + ', hgroup.' + n + ', menu.' + n + ', nav.' + n + ', section.' + n, {
  display: 'block'
});

css.global('ol.' + n + ', ul.' + n, {
  listStyle: 'none'
});

css.global('bloquote.' + n + ', q.' + n, {
  quotes: 'none'
});

css.global('table.' + n, {
  borderCollapse: 'collapse',
  borderSpacing: '0'
});

css.global('input.' + n + ', textarea.' + n, {
  outline: 'none'
});

css.global('strong.' + n, {
  fontWeight: '500'
});

css.global('em.' + n, {
  fontStyle: 'italic'
});

css.global('*.' + n + ', *.' + n + ':before, *.' + n + ':after', {
  boxSizing: 'border-box'
});

var cssBaseStyles = css({
  margin: '0',
  padding: '0',
  border: '0',
  verticalAlign: 'baseline',
  MozOsxFontSmoothing: 'grayscale',
  WebkitFontSmoothing: 'antialiased',
  fontSmoothing: 'antialiased'
});

var Box = function (_React$Component) {
  _inherits(Box, _React$Component);

  function Box() {
    _classCallCheck(this, Box);

    return _possibleConstructorReturn(this, (Box.__proto__ || _Object$getPrototypeOf(Box)).apply(this, arguments));
  }

  _createClass(Box, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          is = _props.is,
          theme = _props.theme,
          onRef = _props.onRef,
          restProps = _objectWithoutProperties(_props, ['is', 'theme', 'onRef']); // eslint-disable-line


      var _parseProps = parseProps(restProps),
          className = _parseProps.className,
          parsedProps = _objectWithoutProperties(_parseProps, ['className']);

      return React.createElement(is, _extends({}, parsedProps, {
        className: cx(n, '' + cssBaseStyles, className)
      }, onRef ? {
        ref: function ref(node) {
          onRef(node);
        }
      } : {}));
    }
  }]);

  return Box;
}(React.Component);

Box.propTypes = propTypes;

Box.defaultProps = {
  is: 'div'
};

Box.displayName = 'Box';

export default Box;