import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import Icon from './Icon';

var DragIcon = function DragIcon(_ref) {
  var stroke = _ref.stroke,
      props = _objectWithoutProperties(_ref, ['stroke']);

  var svgStyle = {
    position: 'relative',
    width: '100%',
    height: '100%',
    pointerEvents: 'none'
  };

  return React.createElement(
    Icon,
    props,
    React.createElement(
      'svg',
      { viewBox: '0 0 9 18', style: svgStyle, xmlns: 'http://www.w3.org/2000/svg' },
      React.createElement(
        'g',
        { stroke: stroke, fill: 'none', fillRule: 'evenodd', strokeLinecap: 'round', strokeLinejoin: 'round' },
        React.createElement('path', { d: 'M.94 1.105h6.75M.94 4.263h6.75M.94 7.42h6.75M.94 10.58h6.75M.94 13.737h6.75M.94 16.895h6.75' })
      )
    )
  );
};

DragIcon.propTypes = _extends({}, Icon.propTypes);

DragIcon.defaultProps = _extends({}, Icon.defaultProps, {
  size: 'small'
});

export default DragIcon;