import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _extends from 'babel-runtime/helpers/extends';

var _css, _css2;

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import Box from './Box';
import theme from './theme';
import offscreenCss from './utils/offscreenCss';
var majorScale = theme.majorScale,
    borderRadius = theme.borderRadius,
    controlStateStyles = theme.controlStateStyles;

var count = 1; // Used for generating unique input names

var labelClass = css(_extends({
  display: 'flex',
  flex: 1,
  alignItems: 'center',
  justifyContent: 'center',
  position: 'relative'
}, controlStateStyles.default));

var wrapperClass = css((_css = {
  position: 'relative',
  display: 'flex',
  flex: 1,
  cursor: 'pointer',
  marginLeft: '-1px'
}, _defineProperty(_css, ':first-child .' + labelClass, {
  borderTopLeftRadius: borderRadius[0],
  borderBottomLeftRadius: borderRadius[0]
}), _defineProperty(_css, ':last-child .' + labelClass, {
  borderTopRightRadius: borderRadius[0],
  borderBottomRightRadius: borderRadius[0]
}), _css));

var inputClass = css((_css2 = {
  ':hover, :focus, :active': _defineProperty({}, '& + .' + labelClass, {
    zIndex: 1
  })
}, _defineProperty(_css2, ':hover + .' + labelClass, _extends({}, controlStateStyles.hover)), _defineProperty(_css2, ':active + .' + labelClass, _extends({}, controlStateStyles.active)), _defineProperty(_css2, ':checked + .' + labelClass, _extends({}, controlStateStyles.checked)), _css2));

function useControlSizes(size) {
  var sizes = theme.controlSizes[size];

  return {
    minHeight: sizes.minHeight,
    minWidth: sizes.minWidth,
    textStyle: sizes.textStyle,
    paddingX: majorScale(1)
  };
}

function SegmentedControlRadio(props) {
  var size = props.size,
      name = props.name,
      label = props.label,
      value = props.value,
      checked = props.checked,
      _onChange = props.onChange;


  return React.createElement(
    'label',
    { className: '' + wrapperClass },
    React.createElement('input', {
      type: 'radio',
      className: offscreenCss + ' ' + inputClass,
      name: name,
      value: value,
      checked: checked,
      onChange: function onChange(e) {
        return _onChange(e.target.value);
      } }),
    React.createElement(
      Box,
      _extends({ className: '' + labelClass }, useControlSizes(size)),
      label
    )
  );
}

SegmentedControlRadio.propTypes = {
  size: PropTypes.oneOf(_Object$keys(theme.controlSizes)),
  name: PropTypes.string.isRequired,
  label: PropTypes.node.isRequired,
  value: PropTypes.string.isRequired,
  checked: PropTypes.bool.isRequired,
  onChange: PropTypes.func.isRequired
};

SegmentedControlRadio.displayName = 'SegmentedControlRadio';

var parseProps = function parseProps(_ref) {
  var className = _ref.className,
      options = _ref.options,
      name = _ref.name,
      value = _ref.value,
      defaultValue = _ref.defaultValue,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, ['className', 'options', 'name', 'value', 'defaultValue', 'onChange']);

  return _extends({}, props);
};

var SegmentedControl = function (_Component) {
  _inherits(SegmentedControl, _Component);

  function SegmentedControl(props) {
    _classCallCheck(this, SegmentedControl);

    var _this = _possibleConstructorReturn(this, (SegmentedControl.__proto__ || _Object$getPrototypeOf(SegmentedControl)).call(this));

    var options = props.options,
        defaultValue = props.defaultValue;


    _this.state = {
      value: defaultValue || options[0].value
    };

    // Default name if the name prop isn't set
    _this.name = 'SegmentedControl-' + count;
    count += 1;

    _this.onChange = _this.onChange.bind(_this);
    return _this;
  }

  _createClass(SegmentedControl, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          size = _props.size;

      var name = this.props.name || this.name;
      // Allows it to behave like a controlled input
      var value = this.props.value || this.state.value;

      return React.createElement(
        Box,
        _extends({ display: 'flex', marginRight: '-1px' }, parseProps(this.props)),
        options.map(function (option) {
          return React.createElement(SegmentedControlRadio, {
            key: option.value,
            size: size,
            name: name,
            label: option.label,
            value: option.value,
            checked: value === option.value,
            onChange: _this2.onChange });
        })
      );
    }
  }, {
    key: 'onChange',
    value: function onChange(value) {
      // Save a render cycle when it's a controlled input
      if (!this.props.value) {
        this.setState({ value: value });
      }

      if (this.props.onChange) {
        this.props.onChange(value);
      }
    }
  }]);

  return SegmentedControl;
}(Component);

SegmentedControl.propTypes = _extends({}, Box.propTypes, {
  options: PropTypes.arrayOf(PropTypes.shape({
    label: PropTypes.node.isRequired,
    value: PropTypes.string.isRequired
  })).isRequired,
  size: PropTypes.oneOf(_Object$keys(theme.controlSizes)),
  name: PropTypes.string,
  value: PropTypes.string,
  defaultValue: PropTypes.string,
  onChange: PropTypes.func
});

SegmentedControl.defaultProps = {
  size: 'default'
};

SegmentedControl.displayName = 'SegmentedControl';

export default SegmentedControl;