import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import React from 'react';
import PropTypes from 'prop-types';
import { css } from 'glamor';
import cx from 'classnames';
import Box from './Box';
import theme from './theme';

var getMuted = function getMuted(val) {
  if (val === undefined) return '';
  switch (val) {
    case 1:
    default:
      return css({ opacity: 0.85 });
    case 2:
      return css({ opacity: 0.7 });
  }
};

var getColor = function getColor(_ref) {
  var white = _ref.white;

  if (white) return css({ color: theme.colors.white });
  return '';
};

var parseProps = function parseProps(_ref2) {
  var className = _ref2.className,
      muted = _ref2.muted,
      white = _ref2.white,
      props = _objectWithoutProperties(_ref2, ['className', 'muted', 'white']);

  return _extends({
    className: cx('' + getColor({ white: white }), '' + getMuted(muted), className)
  }, props);
};

var Text = function Text(props) {
  return React.createElement(Box, parseProps(props));
};

Text.propTypes = {
  white: PropTypes.bool
};

Text.defaultProps = {
  is: 'p'
};

Text.displayName = 'Text';

export default Text;