import _extends from 'babel-runtime/helpers/extends';
import React from 'react';
import { css } from 'glamor';
import Pane from './Pane';
import theme from './theme';
var minorScale = theme.minorScale,
    majorScale = theme.majorScale,
    controlStateStyles = theme.controlStateStyles,
    textColors = theme.textColors,
    borderRadius = theme.borderRadius;


var styles = css({
  display: 'block',
  width: '100%',
  padding: majorScale(1) + ' ' + minorScale(3),
  borderRadius: borderRadius[0],
  backgroundColor: controlStateStyles.default.backgroundColor,
  color: controlStateStyles.default.color,
  border: controlStateStyles.default.border,
  resize: 'vertical',
  transition: controlStateStyles.default.transition,
  transitionProperty: 'border, box-shadow',
  '&:focus': {
    border: controlStateStyles.focus.border,
    boxShadow: controlStateStyles.focus.boxShadow
  },
  '&:disabled': {
    cursor: 'not-allowed',
    backgroundColor: controlStateStyles.disabled.backgroundColor,
    color: controlStateStyles.disabled.color,
    border: controlStateStyles.disabled.border
  },
  '&::placeholder': {
    color: textColors.muted
  }
});

var Textarea = function Textarea(props) {
  return React.createElement(Pane, _extends({}, props, styles));
};

Textarea.defaultProps = {
  is: 'textarea',
  textStyle: 'body1'
};

export default Textarea;