import _extends from 'babel-runtime/helpers/extends';
import React from 'react';
import { css } from 'glamor';
import Box from './Box';
import Text from './Text';
import theme from './theme';
var minorScale = theme.minorScale;


var ValidationMessageLine = function ValidationMessageLine(props) {
  return React.createElement(Box, _extends({}, css({
    borderBottom: '1px solid ' + theme.colors.borderColor,
    borderLeft: '1px solid ' + theme.colors.borderColor,
    borderBottomLeftRadius: theme.borderRadius[0]
  }), props));
};

ValidationMessageLine.defaultProps = {
  width: '8px',
  height: '10px',
  display: 'inline-block',
  position: 'relative',
  marginLeft: 2,
  top: '-3px',
  marginRight: 1
};

ValidationMessageLine.displayName = 'ValidationMessageLine';

var ValidationMessage = function ValidationMessage(props) {
  return React.createElement(
    Box,
    { position: 'relative' },
    React.createElement(ValidationMessageLine, null),
    React.createElement(Text, props)
  );
};

ValidationMessage.defaultProps = {
  textStyle: 'body2',
  display: 'inline-block',
  paddingTop: minorScale(1),
  muted: 2
};

ValidationMessage.displayName = 'ValidationMessage';

export default ValidationMessage;