import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import PropTypes from 'prop-types';

export var propTypes = {
  borderColor: PropTypes.string,
  border: PropTypes.bool,
  borderLeft: PropTypes.bool,
  borderRight: PropTypes.bool,
  borderTop: PropTypes.bool,
  borderBottom: PropTypes.bool
};

var parseProps = function parseProps(_ref) {
  var border = _ref.border,
      borderColor = _ref.borderColor,
      borderLeft = _ref.borderLeft,
      borderRight = _ref.borderRight,
      borderTop = _ref.borderTop,
      borderBottom = _ref.borderBottom,
      style = _ref.style,
      props = _objectWithoutProperties(_ref, ['border', 'borderColor', 'borderLeft', 'borderRight', 'borderTop', 'borderBottom', 'style']);

  var styles = {};

  if (border || borderLeft) styles.borderLeft = '1px solid';
  if (border || borderRight) styles.borderRight = '1px solid';
  if (border || borderTop) styles.borderTop = '1px solid';
  if (border || borderBottom) styles.borderBottom = '1px solid';
  if (border || borderColor) styles.borderColor = borderColor;

  return _extends({ style: _extends({}, styles, style) }, props);
};
export { parseProps };