import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import PropTypes from 'prop-types';

export var propTypes = {
  position: PropTypes.oneOf(['relative', 'absolute', 'fixed', 'static']),
  top: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  right: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  bottom: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  left: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};

var parseProps = function parseProps(_ref) {
  var position = _ref.position,
      top = _ref.top,
      right = _ref.right,
      bottom = _ref.bottom,
      left = _ref.left,
      style = _ref.style,
      props = _objectWithoutProperties(_ref, ['position', 'top', 'right', 'bottom', 'left', 'style']);

  var newStyles = {};

  if (position !== undefined) newStyles.position = position;
  if (top !== undefined) newStyles.top = top;
  if (right !== undefined) newStyles.right = right;
  if (bottom !== undefined) newStyles.bottom = bottom;
  if (left !== undefined) newStyles.left = left;

  return _extends({ style: _extends({}, newStyles, style) }, props);
};
export { parseProps };