import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import PropTypes from 'prop-types';

export var propTypes = {
  padding: PropTypes.number,
  paddingTop: PropTypes.number,
  paddingRight: PropTypes.number,
  paddingBottom: PropTypes.number,
  paddingLeft: PropTypes.number,
  paddingX: PropTypes.number,
  paddingY: PropTypes.number,
  margin: PropTypes.number,
  marginTop: PropTypes.number,
  marginRight: PropTypes.number,
  marginBottom: PropTypes.number,
  marginLeft: PropTypes.number,
  marginX: PropTypes.number,
  marginY: PropTypes.number
};

var parseStyleProps = function parseStyleProps(_ref) {
  var all = _ref.all,
      top = _ref.top,
      right = _ref.right,
      bottom = _ref.bottom,
      left = _ref.left;

  var pAll = all || 0;
  return (top || pAll) + ' ' + (right || pAll) + ' ' + (bottom || pAll) + ' ' + (left || pAll);
};

var parseProps = function parseProps(_ref2) {
  var padding = _ref2.padding,
      paddingTop = _ref2.paddingTop,
      paddingRight = _ref2.paddingRight,
      paddingBottom = _ref2.paddingBottom,
      paddingLeft = _ref2.paddingLeft,
      paddingX = _ref2.paddingX,
      paddingY = _ref2.paddingY,
      margin = _ref2.margin,
      marginTop = _ref2.marginTop,
      marginRight = _ref2.marginRight,
      marginBottom = _ref2.marginBottom,
      marginLeft = _ref2.marginLeft,
      marginX = _ref2.marginX,
      marginY = _ref2.marginY,
      style = _ref2.style,
      props = _objectWithoutProperties(_ref2, ['padding', 'paddingTop', 'paddingRight', 'paddingBottom', 'paddingLeft', 'paddingX', 'paddingY', 'margin', 'marginTop', 'marginRight', 'marginBottom', 'marginLeft', 'marginX', 'marginY', 'style']);

  var styles = {};

  if (padding !== undefined || paddingTop !== undefined || paddingRight !== undefined || paddingBottom !== undefined || paddingLeft !== undefined || paddingX !== undefined || paddingY !== undefined) {
    styles.padding = parseStyleProps({
      all: padding,
      top: paddingTop !== undefined ? paddingTop : paddingY,
      right: paddingRight !== undefined ? paddingRight : paddingX,
      bottom: paddingBottom !== undefined ? paddingBottom : paddingY,
      left: paddingLeft !== undefined ? paddingLeft : paddingX
    });
  }

  if (margin !== undefined || marginTop !== undefined || marginRight !== undefined || marginBottom !== undefined || marginLeft !== undefined || marginX !== undefined || marginY !== undefined) {
    styles.margin = parseStyleProps({
      all: margin,
      top: marginTop !== undefined ? marginTop : marginY,
      right: marginRight !== undefined ? marginRight : marginX,
      bottom: marginBottom !== undefined ? marginBottom : marginY,
      left: marginLeft !== undefined ? marginLeft : marginX
    });
  }

  return _extends({ style: _extends({}, styles, style) }, props);
};
export { parseProps };