import _extends from 'babel-runtime/helpers/extends';
import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, Text, NavigationBar, NavigationBarLink, SubNavigationBar, SubNavigationBarLink, Sidebar, SidebarLink, Avatar, Box, Link, Triangle, Input, Button, theme } from '../components';
var majorScale = theme.majorScale;


var Label = function Label(props) {
  return React.createElement(Text, _extends({ is: 'label', textStyle: 'display4', bold: true, display: 'block' }, props));
};

var AvatarWithTriangle = function AvatarWithTriangle() {
  return React.createElement(
    Box,
    { display: 'inline-flex', alignItems: 'center' },
    React.createElement(
      Avatar,
      { marginLeft: majorScale(1), marginRight: majorScale(1), src: '', imageSize: 'small' },
      'Segment Sloth'
    ),
    React.createElement(Triangle, { aim: 'down', display: 'inline-flex', fill: 'white' })
  );
};

export default function layoutsStory(module) {
  storiesOf('Layouts', module).add('tabbed Nav + Sub Nav', function () {
    return React.createElement(
      App,
      null,
      React.createElement(
        NavigationBar,
        { left: 'Sloth Corp Media', right: React.createElement(AvatarWithTriangle, null) },
        React.createElement(
          NavigationBarLink,
          { active: true },
          'Sources'
        ),
        React.createElement(
          NavigationBarLink,
          { href: '#' },
          'Warehouses'
        )
      ),
      React.createElement(
        SubNavigationBar,
        { left: 'Sources' },
        ['Overview', 'Integrations', 'Debugger', 'Schema', 'Settings'].map(function (name) {
          return React.createElement(
            SubNavigationBarLink,
            { key: name, href: '#', active: name === 'Settings' },
            name
          );
        })
      ),
      React.createElement(
        Pane,
        { flexAuto: true, display: 'flex' },
        React.createElement(
          Sidebar,
          null,
          React.createElement(
            SidebarLink,
            { key: 'Basic', href: '#', active: true },
            'Basic'
          ),
          React.createElement(
            SidebarLink,
            { key: 'Collaborators', href: '#' },
            'Collaborators'
          ),
          React.createElement(
            SidebarLink,
            { key: 'Settings', href: '#' },
            'SQL Settings'
          ),
          React.createElement(
            SidebarLink,
            { key: 'Schema', href: '#' },
            'Clear Schema'
          ),
          React.createElement(
            SidebarLink,
            { key: 'Workspace', href: '#' },
            'Transfer To Workspace'
          ),
          React.createElement(
            SidebarLink,
            { key: 'Keys', href: '#' },
            'API Keys'
          )
        ),
        React.createElement(
          Pane,
          { display: 'flex', flexAuto: true, justifyContent: 'center' },
          React.createElement(
            Pane,
            { width: '680px', margin: majorScale(6) },
            React.createElement(
              Pane,
              { white: true, rounded: true, border: true, padding: majorScale(6) },
              React.createElement(
                Text,
                { is: 'h2', textStyle: 'display2', marginBottom: majorScale(4) },
                'Basic Settings'
              ),
              React.createElement(
                Label,
                { htmlFor: 'Nickname' },
                'Nickname'
              ),
              React.createElement(Input, { readOnly: true, id: 'Nickname', value: 'Slothzilla', name: 'Nickname', marginTop: majorScale(1), marginBottom: majorScale(1) }),
              React.createElement(
                Text,
                { textStyle: 'body2' },
                'Pick a name to help you identify this source in Segment.'
              ),
              React.createElement(
                Button,
                { primary: true, marginTop: majorScale(4) },
                'Save changes'
              ),
              React.createElement(
                Pane,
                { white: true, borderTop: true, textStyle: 'body2', marginTop: majorScale(4), paddingTop: majorScale(4) },
                React.createElement(
                  Link,
                  { underline: true, primary: true, href: '' },
                  'Delete this source.'
                ),
                ' No data will be deleted from your source.'
              )
            )
          )
        )
      )
    );
  });
}