import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, Link, Text, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function linkStory(module) {
  storiesOf('Link', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Link\n\nThe Link component is a `a` or `span` element. Implement the `<Text />` component.\n\n```\n<Text textStyle=\'body1\'>\n  <Link underline href=\'\'>Primary Link by default</Link><br/>\n  <Link underline secondary href=\'\'>Secondary Link</Link><br/>\n  <Link underline danger href=\'\'>danger Link</Link><br/>\n  <Link underline={false} active href=\'\'>Active Link becomes a span</Link>\n</Text>\n<Text textStyle=\'display2\'>\n  <Link underline href=\'\'>Primary Link by default</Link><br/>\n</Text>\n```\n\n'
        ),
        React.createElement(
          Text,
          { textStyle: 'body1' },
          React.createElement(
            Link,
            { underline: true, href: '' },
            'Primary Link by default'
          ),
          React.createElement('br', null),
          React.createElement(
            Link,
            { underline: true, secondary: true, href: '' },
            'Secondary Link'
          ),
          React.createElement('br', null),
          React.createElement(
            Link,
            { underline: true, danger: true, href: '' },
            'danger Link'
          ),
          React.createElement('br', null),
          React.createElement(
            Link,
            { underline: false, active: true, href: '' },
            'Active Link becomes a span'
          )
        ),
        React.createElement(
          Text,
          { textStyle: 'display2' },
          React.createElement(
            Link,
            { underline: true, href: '' },
            'Primary Link by default'
          ),
          React.createElement('br', null)
        ),
        React.createElement(
          Content,
          { markdown: true },
          '\nprop | type | default | description\n-----|------|----------|-------------\n`underline` | boolean | true | text-decoration: underline;\n`primary` | boolean | true |primary intent styling\n`secondary` | boolean | undefined | secondary intent styling\n`danger` | boolean | undefined | danger intent styling\n`active` | boolean | undefined | becomes a span and gets active className\n'
        )
      )
    );
  });
}