import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, Button, Portal, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function portalStory(module) {
  storiesOf('Portal', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Portal\n\n**Available since v2.4.0**\n\nConvenience wrapper around [React\'s Portal API](https://reactjs.org/docs/portals.html).\n\nThe Portal component transports it\'s children outside of the current DOM tree\nand appends it to body. It\'s used by the `Popover` component internally.\n\n```\n<Portal>\n  <Button primary>Hello world</Button>\n</Portal>\n```\n\n'
        ),
        React.createElement(
          Portal,
          null,
          React.createElement(
            Button,
            { primary: true },
            'Hello world'
          )
        ),
        React.createElement(
          Content,
          { markdown: true },
          '\nprop | version | type | default | description\n-----|---------|------| --------|-------------\n`children` | v2.4.0 | node | `undefined` | appends component to the body outside of the current DOM tree\n'
        )
      )
    );
  });
}