import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Pane, Radio, Box, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;

var AdvancedExample = function (_React$Component) {
  _inherits(AdvancedExample, _React$Component);

  function AdvancedExample() {
    _classCallCheck(this, AdvancedExample);

    var _this = _possibleConstructorReturn(this, (AdvancedExample.__proto__ || _Object$getPrototypeOf(AdvancedExample)).call(this));

    _this.state = {
      checkedParent: null,
      checkedChild: null,
      otherText: null
    };

    _this.onSelectParent = _this.onSelectParent.bind(_this);
    _this.onSelectChild = _this.onSelectChild.bind(_this);
    return _this;
  }

  _createClass(AdvancedExample, [{
    key: 'render',
    value: function render() {
      var _state = this.state,
          checkedParent = _state.checkedParent,
          checkedChild = _state.checkedChild;

      return React.createElement(
        'form',
        null,
        React.createElement(
          Radio,
          { name: 'exampleParent', value: 'parentBasic', checked: checkedParent === 'parentBasic', onChange: this.onSelectParent },
          'Here is a basic example.'
        ),
        React.createElement(
          Radio,
          { name: 'exampleParent', value: 'parentNested', checked: checkedParent === 'parentNested', onChange: this.onSelectParent },
          'Click me to see what nested radio looks like.'
        ),
        checkedParent === 'parentNested' && React.createElement(
          Box,
          { marginLeft: majorScale(3) },
          React.createElement(
            Radio,
            { name: 'exampleChild', value: 'childFirst', checked: checkedChild === 'childFirst', onChange: this.onSelectChild },
            'Here is a nested radio button.'
          ),
          React.createElement(
            Radio,
            { name: 'exampleChild', value: 'childSecond', checked: checkedChild === 'childSecond', onChange: this.onSelectChild },
            'Nested radio buttons only show when their parent is selected.'
          ),
          React.createElement(
            Radio,
            { name: 'exampleChild', value: 'childThird', checked: checkedChild === 'childThird', onChange: this.onSelectChild },
            'They should be hidden once the parent gets unselected.'
          ),
          React.createElement(
            Radio,
            { name: 'exampleChild', value: 'childFourth', checked: checkedChild === 'childFourth', onChange: this.onSelectChild },
            'Here is a basic margin top example.'
          )
        ),
        React.createElement(
          Radio,
          { name: 'exampleParent', value: 'parentLast', checked: checkedParent === 'parentLast', onChange: this.onSelectParent },
          'Here is one last radio button.'
        )
      );
    }
  }, {
    key: 'onSelectParent',
    value: function onSelectParent(e) {
      this.setState({
        checkedParent: e.target.value,
        checkedChild: null
      });
    }
  }, {
    key: 'onSelectChild',
    value: function onSelectChild(e) {
      this.setState({
        checkedChild: e.target.value
      });
    }
  }]);

  return AdvancedExample;
}(React.Component);

export default function radioStory(module) {
  storiesOf('Radio', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Radio\n\n**Available since v4.1.0**\n\nThe Radio component is an `input` element. Implement the `<Box />` component.\n\n```\n<Radio name=\'example\' value=\'basic\'>Here is a basic example.</Radio>\n<Radio name=\'example\' value=\'checked\' checked>Here is basic checked example.</Radio>\n<Radio name=\'example\' value=\'margin\' marginTop=\'25px\'>Here is a basic margin top example.</Radio>\n<Radio name=\'example\' value=\'disabled\' disabled>Here is a basic disabled state example.</Radio>\n```\n\n'
        ),
        React.createElement(
          Radio,
          { name: 'example', value: 'basic' },
          'Here is a basic example.'
        ),
        React.createElement(
          Radio,
          { name: 'example', value: 'checked', checked: true },
          'Here is basic checked example.'
        ),
        React.createElement(
          Radio,
          { name: 'example', value: 'margin', marginTop: '25px' },
          'Here is a basic margin top example.'
        ),
        React.createElement(
          Radio,
          { name: 'example', value: 'disabled', disabled: true },
          'Here is a basic disabled state example.'
        ),
        React.createElement(
          Content,
          { markdown: true },
          '\n\n# Advanced example\n\n```\nclass AdvancedExample extends React.Component {\n  constructor () {\n    super()\n\n    this.state = {\n      checkedParent: null,\n      checkedChild: null,\n      otherText: null\n    }\n\n    this.onSelectParent = this.onSelectParent.bind(this)\n    this.onSelectChild = this.onSelectChild.bind(this)\n  }\n\n  render () {\n    const { checkedParent, checkedChild } = this.state\n    return (\n      <form>\n        <Radio name=\'exampleParent\' value=\'parentBasic\' checked={checkedParent === \'parentBasic\'} onChange={this.onSelectParent}>Here is a basic example.</Radio>\n        <Radio name=\'exampleParent\' value=\'parentNested\' checked={checkedParent === \'parentNested\'} onChange={this.onSelectParent}>Click me to see what nested radio looks like.</Radio>\n        {checkedParent === \'parentNested\' &&\n          <Box marginLeft={majorScale(3)}>\n            <Radio name=\'exampleChild\' value=\'childFirst\' checked={checkedChild === \'childFirst\'} onChange={this.onSelectChild}>Here is a nested radio button.</Radio>\n            <Radio name=\'exampleChild\' value=\'childSecond\' checked={checkedChild === \'childSecond\'} onChange={this.onSelectChild}>Nested radio buttons only show when their parent is selected.</Radio>\n            <Radio name=\'exampleChild\' value=\'childThird\' checked={checkedChild === \'childThird\'} onChange={this.onSelectChild}>They should be hidden once the parent gets unselected.</Radio>\n            <Radio name=\'exampleChild\' value=\'childFourth\' checked={checkedChild === \'childFourth\'} onChange={this.onSelectChild}>Here is a basic margin top example.</Radio>\n          </Box>\n        }\n        <Radio name=\'exampleParent\' value=\'parentLast\' checked={checkedParent === \'parentLast\'} onChange={this.onSelectParent}>Here is one last radio button.</Radio>\n      </form>\n    )\n  }\n\n  onSelectParent (e) {\n    this.setState({\n      checkedParent: e.target.value,\n      checkedChild: null\n    })\n  }\n\n  onSelectChild (e) {\n    this.setState({\n      checkedChild: e.target.value\n    })\n  }\n}\n```\n\n'
        ),
        React.createElement(AdvancedExample, null)
      )
    );
  });
}