import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Spinner, Pane, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function spinnerStory(module) {
  storiesOf('Spinner', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Spinner\n\nThe Spinner component. Implement the `<Box />` component.\n\ndefaultProps:\n`width: \'32px\'`\n`height: \'32px\'`\n\n```\n<Spinner />\n```\n\n'
        ),
        React.createElement(Spinner, null)
      )
    );
  }).add('standalone', function () {
    return React.createElement(Spinner, null);
  });
}