import React from 'react';
import { storiesOf } from '@storybook/react';
import { App, Input, Pane, ValidationMessage, theme } from '../components';
import Content from './Content';
var majorScale = theme.majorScale;


export default function validationMessageStory(module) {
  storiesOf('Validation Message', module).add('usage', function () {
    return React.createElement(
      App,
      { white: true },
      React.createElement(
        Pane,
        { white: true, padding: majorScale(10) },
        React.createElement(
          Content,
          { markdown: true },
          '\n# Validation Message\n\nThe ValidationMessage component is used under a  `Input` component. Implement the `<Box />` component.\n\n```\n<Input warning />\n<ValidationMessage>Please fill in a valid email</ValidationMessage>\n```\n\n'
        ),
        React.createElement(Input, { warning: true }),
        React.createElement(
          ValidationMessage,
          null,
          'Please fill in a valid email'
        )
      )
    );
  }).add('standalone', function () {
    return React.createElement(
      ValidationMessage,
      null,
      'Please fill in a valid email'
    );
  });
}