'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _Text = require('./Text');

var _Text2 = _interopRequireDefault(_Text);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var majorScale = _theme2.default.majorScale;

var AvatarImage = function (_Component) {
  _inherits(AvatarImage, _Component);

  function AvatarImage(props, context) {
    _classCallCheck(this, AvatarImage);

    var _this = _possibleConstructorReturn(this, (AvatarImage.__proto__ || Object.getPrototypeOf(AvatarImage)).call(this, props, context));

    _this.handleError = _this.handleError.bind(_this);
    _this.state = {
      failed: false
    };
    return _this;
  }

  _createClass(AvatarImage, [{
    key: 'handleError',
    value: function handleError() {
      this.setState({ failed: true });
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.failed || !this.props.src) return null;
      return _react2.default.createElement(_Box2.default, _extends({
        is: 'img',
        src: this.props.src,
        onError: this.handleError,
        height: '100%',
        width: '100%'
      }, this.props));
    }
  }]);

  return AvatarImage;
}(_react.Component);

var AvatarName = function AvatarName(_ref) {
  var children = _ref.children;

  return _react2.default.createElement(
    _Text2.default,
    { textStyle: 'body1', truncate: true },
    children
  );
};

var AvatarCircle = function AvatarCircle(props) {
  return _react2.default.createElement(_Box2.default, _extends({ display: 'inline-block', circle: true, overflow: 'hidden' }, props));
};

var AvatarInitials = function AvatarInitials(props) {
  return _react2.default.createElement(_Text2.default, _extends({ top: '0', position: 'absolute', white: true }, props));
};

function getInitials(name) {
  if (!name || typeof name !== 'string') return '?';
  return name.replace(/\s+/, ' ').split(' ').slice(0, 2).map(function (v) {
    return v[0];
  }).join('');
}

var AvatarImageSize = {
  small: majorScale(4),
  default: majorScale(5)
};

var Avatar = function Avatar(_ref2) {
  var src = _ref2.src,
      imageSize = _ref2.imageSize,
      initialsFontSize = _ref2.initialsFontSize,
      children = _ref2.children,
      nameShown = _ref2.nameShown,
      width = _ref2.width,
      nameWidth = _ref2.nameWidth,
      backgroundColor = _ref2.backgroundColor,
      props = _objectWithoutProperties(_ref2, ['src', 'imageSize', 'initialsFontSize', 'children', 'nameShown', 'width', 'nameWidth', 'backgroundColor']);

  var size = AvatarImageSize.hasOwnProperty(imageSize) ? AvatarImageSize[imageSize] : imageSize;
  return _react2.default.createElement(
    _Box2.default,
    _extends({ title: children, textAlign: 'center' }, props),
    _react2.default.createElement(
      AvatarCircle,
      {
        position: 'relative',
        backgroundColor: backgroundColor,
        width: size,
        height: size
      },
      _react2.default.createElement(AvatarImage, { src: src, position: 'relative', style: { zIndex: 1 } }),
      _react2.default.createElement(
        AvatarInitials,
        {
          width: size,
          height: size,
          textStyle: parseInt(size, 10) >= parseInt(AvatarImageSize.default, 10) ? 'body1' : 'body2',
          style: { lineHeight: size + 'px', fontSize: initialsFontSize }
        },
        getInitials(children)
      )
    ),
    nameShown ? _react2.default.createElement(
      AvatarName,
      { width: nameWidth },
      children
    ) : null
  );
};

Avatar.propTypes = {
  showName: _propTypes2.default.bool,
  children: _propTypes2.default.string,
  nameWidth: _propTypes2.default.string,
  imageSize: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.oneOf(['small', 'default'])]),
  initialFontSize: _propTypes2.default.string,
  backgroundColor: _propTypes2.default.string
};

Avatar.defaultProps = {
  nameWidth: majorScale(13),
  display: 'inline-block',
  imageSize: 'default',
  nameShown: false,
  backgroundColor: _theme2.default.colors.primary
};

exports.default = Avatar;