'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _Pane = require('./Pane');

var _Pane2 = _interopRequireDefault(_Pane);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Text = require('./Text');

var _Text2 = _interopRequireDefault(_Text);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var majorScale = _theme2.default.majorScale,
    minorScale = _theme2.default.minorScale;


var BottomSheetTopBar = function BottomSheetTopBar(_ref) {
  var left = _ref.left,
      right = _ref.right,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['left', 'right', 'children']);

  return _react2.default.createElement(
    _Pane2.default,
    _extends({ display: 'flex', top: '0', position: 'fixed', width: '100%', style: { zIndex: '10' }, alignItems: 'center', shadow: true, white: true }, props),
    _react2.default.createElement(
      _Pane2.default,
      { width: '33%', height: '100%', padding: minorScale(2), display: 'flex' },
      left
    ),
    _react2.default.createElement(
      _Pane2.default,
      { flexAuto: true, textAlign: 'center' },
      children
    ),
    _react2.default.createElement(
      _Pane2.default,
      { width: '33%', textAlign: 'right', padding: minorScale(2) },
      right
    )
  );
};

BottomSheetTopBar.propTypes = {
  left: _propTypes2.default.node,
  right: _propTypes2.default.node
};

BottomSheetTopBar.displayName = 'BottomSheetTopBar';

var BottomSheetCloseButton = function BottomSheetCloseButton(props) {
  return _react2.default.createElement(
    _Button2.default,
    _extends({ paddingX: majorScale(3) }, props),
    'Cancel'
  );
};

var slideInAnimation = _glamor.css.keyframes('slideInAnimation', {
  from: {
    transform: 'translateY(100%)'
  },
  to: {
    transform: 'translateY(0)'
  }
});

var slideOutAnimation = _glamor.css.keyframes('slideOutAnimation', {
  from: {
    transform: 'translateY(0)'
  },
  to: {
    transform: 'translateY(100%)'
  }
});

var BottomSheetPane = function BottomSheetPane(_ref2) {
  var slideOut = _ref2.slideOut,
      props = _objectWithoutProperties(_ref2, ['slideOut']);

  return _react2.default.createElement(_Pane2.default, _extends({}, (0, _glamor.css)({
    transform: 'translateZ(0)',
    animation: (slideOut ? slideOutAnimation : slideInAnimation) + ' ' + _theme2.default.animationDuration.slow + ' ' + _theme2.default.animationEasing.deceleration
  }), props));
};

BottomSheetPane.propTypes = {
  slideOut: _propTypes2.default.bool
};

BottomSheetPane.defaultProps = {
  tint: true,
  position: 'absolute',
  shadow: true,
  height: '100vh',
  paddingTop: majorScale(7),
  left: 0,
  right: 0,
  bottom: 0
};

BottomSheetPane.displayName = 'BottomSheetPane';

var BottomSheet = function (_Component) {
  _inherits(BottomSheet, _Component);

  function BottomSheet(props, context) {
    _classCallCheck(this, BottomSheet);

    var _this = _possibleConstructorReturn(this, (BottomSheet.__proto__ || Object.getPrototypeOf(BottomSheet)).call(this, props, context));

    _this.handleClose = _this.handleClose.bind(_this);
    _this.handleAnimationEnd = _this.handleAnimationEnd.bind(_this);

    _this.state = {
      isClosing: false
    };
    return _this;
  }

  _createClass(BottomSheet, [{
    key: 'handleClose',
    value: function handleClose() {
      this.setState({ isClosing: true });
    }
  }, {
    key: 'handleAnimationEnd',
    value: function handleAnimationEnd() {
      if (!this.state.isClosing) return;
      this.props.onClose();
      this.setState({ isClosing: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          isOpen = _props.isOpen,
          children = _props.children,
          navigationBarLeft = _props.navigationBarLeft,
          navigationBarRight = _props.navigationBarRight,
          title = _props.title,
          props = _objectWithoutProperties(_props, ['isOpen', 'children', 'navigationBarLeft', 'navigationBarRight', 'title']);

      var isClosing = this.state.isClosing;


      if (!isOpen) return null;

      return _react2.default.createElement(
        _Overlay2.default,
        { onClick: this.handleClose, fadeOut: isClosing, onFadeEnd: this.handleAnimationEnd },
        _react2.default.createElement(
          BottomSheetPane,
          _extends({ onClick: function onClick(e) {
              return e.stopPropagation();
            }, slideOut: isClosing }, props),
          _react2.default.createElement(
            BottomSheetTopBar,
            { left: _react2.default.cloneElement(navigationBarLeft, { onClick: this.handleClose }), right: navigationBarRight },
            _react2.default.createElement(
              _Text2.default,
              { is: 'h2', textStyle: 'display4' },
              title
            )
          ),
          _react2.default.createElement(
            _Pane2.default,
            { style: { overflowY: 'auto' }, height: '100%' },
            children
          )
        )
      );
    }
  }]);

  return BottomSheet;
}(_react.Component);

BottomSheet.propTypes = {
  isOpen: _propTypes2.default.bool,
  onClose: _propTypes2.default.func,
  navigationBarLeft: _propTypes2.default.node,
  navigationBarRight: _propTypes2.default.node,
  title: _propTypes2.default.string
};

BottomSheet.defaultProps = {
  isOpen: true,
  navigationBarLeft: _react2.default.createElement(BottomSheetCloseButton, null),
  navigationBarRight: null,
  title: null
};

BottomSheet.displayName = 'BottomSheet';

exports.default = BottomSheet;