'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SidebarLink = exports.Sidebar = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _glamor = require('glamor');

var _Pane = require('./Pane');

var _Pane2 = _interopRequireDefault(_Pane);

var _Text = require('./Text');

var _Text2 = _interopRequireDefault(_Text);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _Triangle = require('./Triangle');

var _Triangle2 = _interopRequireDefault(_Triangle);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var minorScale = _theme2.default.minorScale,
    majorScale = _theme2.default.majorScale;


var SidebarLink = function SidebarLink(_ref) {
  var children = _ref.children,
      active = _ref.active,
      props = _objectWithoutProperties(_ref, ['children', 'active']);

  return _react2.default.createElement(
    _Link2.default,
    _extends({ textStyle: 'body1' }, (0, _glamor.css)({
      '&:hover, &.active': {
        backgroundColor: _theme2.default.rawColors.blue50
      }
    }), { active: active }, props),
    _react2.default.createElement(
      _Text2.default,
      { is: 'span', flexAuto: true },
      children
    ),
    active ? _react2.default.createElement(_Triangle2.default, { aim: 'right', fill: _theme2.default.intent.secondary.active.linkColor }) : null
  );
};

SidebarLink.defaultProps = {
  is: 'a',
  secondary: true,
  display: 'flex',
  alignItems: 'center',
  paddingX: majorScale(1),
  paddingY: minorScale(1),
  marginBottom: minorScale(1),
  rounded: true
};

var Sidebar = function Sidebar(props) {
  return _react2.default.createElement(_Pane2.default, props);
};

Sidebar.defaultProps = {
  white: true,
  borderRight: true,
  width: majorScale(30),
  padding: majorScale(2),
  flex: '0 0 auto'
};

exports.Sidebar = Sidebar;
exports.SidebarLink = SidebarLink;