'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _glamor = require('glamor');

var _Pane = require('./Pane');

var _Pane2 = _interopRequireDefault(_Pane);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minorScale = _theme2.default.minorScale,
    majorScale = _theme2.default.majorScale,
    controlStateStyles = _theme2.default.controlStateStyles,
    textColors = _theme2.default.textColors,
    borderRadius = _theme2.default.borderRadius;


var styles = (0, _glamor.css)({
  display: 'block',
  width: '100%',
  padding: majorScale(1) + ' ' + minorScale(3),
  borderRadius: borderRadius[0],
  backgroundColor: controlStateStyles.default.backgroundColor,
  color: controlStateStyles.default.color,
  border: controlStateStyles.default.border,
  resize: 'vertical',
  transition: controlStateStyles.default.transition,
  transitionProperty: 'border, box-shadow',
  '&:focus': {
    border: controlStateStyles.focus.border,
    boxShadow: controlStateStyles.focus.boxShadow
  },
  '&:disabled': {
    cursor: 'not-allowed',
    backgroundColor: controlStateStyles.disabled.backgroundColor,
    color: controlStateStyles.disabled.color,
    border: controlStateStyles.disabled.border
  },
  '&::placeholder': {
    color: textColors.muted
  }
});

var Textarea = function Textarea(props) {
  return _react2.default.createElement(_Pane2.default, _extends({}, props, styles));
};

Textarea.defaultProps = {
  is: 'textarea',
  textStyle: 'body1'
};

exports.default = Textarea;