'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = abbreviateNumber;

var _humanizeNumber = require('humanize-number');

var _humanizeNumber2 = _interopRequireDefault(_humanizeNumber);

var _roundTo = require('round-to');

var _roundTo2 = _interopRequireDefault(_roundTo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function abbreviateNumber(value) {
  if (value >= 1000000000) {
    var num = value / 1000000000; // 1,000,000,000
    num = (0, _roundTo2.default)(num, 2);
    return (0, _humanizeNumber2.default)(num) + ' B';
  } else if (value >= 1000000) {
    var _num = value / 1000000; // 1,000,000
    _num = (0, _roundTo2.default)(_num, 2);
    return (0, _humanizeNumber2.default)(_num) + ' M';
  } else if (value >= 1000) {
    var _num2 = value / 1000; // 1,000
    _num2 = (0, _roundTo2.default)(_num2, 2);
    return (0, _humanizeNumber2.default)(_num2) + ' K';
  } else {
    return (0, _humanizeNumber2.default)(value);
  }
}