'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  width: _propTypes2.default.string,
  height: _propTypes2.default.string,
  minWidth: _propTypes2.default.string,
  minHeight: _propTypes2.default.string,
  maxWidth: _propTypes2.default.string,
  maxHeight: _propTypes2.default.string
};

var parseProps = function parseProps(_ref) {
  var width = _ref.width,
      height = _ref.height,
      minWidth = _ref.minWidth,
      minHeight = _ref.minHeight,
      maxWidth = _ref.maxWidth,
      maxHeight = _ref.maxHeight,
      style = _ref.style,
      props = _objectWithoutProperties(_ref, ['width', 'height', 'minWidth', 'minHeight', 'maxWidth', 'maxHeight', 'style']);

  var styles = {};

  if (width) {
    styles.width = width;
  }

  if (height) styles.height = height;

  if (minWidth) styles.minWidth = minWidth;
  if (minHeight) styles.minHeight = minHeight;
  if (maxWidth) styles.maxWidth = maxWidth;
  if (maxHeight) styles.maxHeight = maxHeight;

  return _extends({ style: _extends({}, styles, style) }, props);
};
exports.parseProps = parseProps;