'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  flex: _propTypes2.default.string,
  flexAuto: _propTypes2.default.bool,
  flexNone: _propTypes2.default.bool,
  flexColumn: _propTypes2.default.bool,
  flexWrap: _propTypes2.default.bool,
  alignItems: _propTypes2.default.oneOf(['stretch', 'center', 'baseline', 'flex-start', 'flex-end']),
  justifyContent: _propTypes2.default.oneOf(['center', 'space-around', 'space-between', 'flex-start', 'flex-end']),
  flexDirection: _propTypes2.default.oneOf(['row', 'row-reverse', 'column', 'column-reverse']),
  flexGrow: _propTypes2.default.string,
  flexShrink: _propTypes2.default.string
};

var getFlex = function getFlex(_ref) {
  var flex = _ref.flex,
      flexAuto = _ref.flexAuto,
      flexNone = _ref.flexNone;

  if (flexAuto) return { flex: 'auto' };
  if (flexNone) return { flex: 'none' };
  if (flex) return { flex: flex };
  return {};
};

var getFlexDirection = function getFlexDirection(_ref2) {
  var flexColumn = _ref2.flexColumn,
      flexDirection = _ref2.flexDirection;

  if (flexColumn) return { flexDirection: 'column' };
  if (flexDirection) return { flexDirection: flexDirection };
  return {};
};

var getFlexWrap = function getFlexWrap(_ref3) {
  var flexWrap = _ref3.flexWrap;

  if (flexWrap) return { flexWrap: 'wrap' };
  return {};
};

var parseProps = function parseProps(_ref4) {
  var flex = _ref4.flex,
      flexAuto = _ref4.flexAuto,
      flexNone = _ref4.flexNone,
      flexColumn = _ref4.flexColumn,
      flexDirection = _ref4.flexDirection,
      flexWrap = _ref4.flexWrap,
      alignItems = _ref4.alignItems,
      justifyContent = _ref4.justifyContent,
      flexShrink = _ref4.flexShrink,
      flexGrow = _ref4.flexGrow,
      className = _ref4.className,
      props = _objectWithoutProperties(_ref4, ['flex', 'flexAuto', 'flexNone', 'flexColumn', 'flexDirection', 'flexWrap', 'alignItems', 'justifyContent', 'flexShrink', 'flexGrow', 'className']);

  if (flex !== undefined || flexAuto !== undefined || flexNone !== undefined || flexColumn !== undefined || flexDirection !== undefined || flexWrap !== undefined || alignItems !== undefined || justifyContent !== undefined || flexShrink !== undefined || flexGrow !== undefined) {
    return _extends({
      className: (0, _classnames2.default)(className, '' + (0, _glamor.css)(_extends({}, getFlex({ flex: flex, flexAuto: flexAuto, flexNone: flexNone }), getFlexDirection({ flexColumn: flexColumn, flexDirection: flexDirection }), getFlexWrap({ flexWrap: flexWrap }), alignItems ? { alignItems: alignItems } : {}, justifyContent ? { justifyContent: justifyContent } : {}, flexShrink ? { flexShrink: flexShrink } : {}, flexGrow ? { flexGrow: flexGrow } : {})))
    }, props);
  }

  return _extends({ className: className }, props);
};
exports.parseProps = parseProps;