'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  position: _propTypes2.default.oneOf(['relative', 'absolute', 'fixed', 'static']),
  top: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  right: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  bottom: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  left: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
};

var parseProps = function parseProps(_ref) {
  var position = _ref.position,
      top = _ref.top,
      right = _ref.right,
      bottom = _ref.bottom,
      left = _ref.left,
      style = _ref.style,
      props = _objectWithoutProperties(_ref, ['position', 'top', 'right', 'bottom', 'left', 'style']);

  var newStyles = {};

  if (position !== undefined) newStyles.position = position;
  if (top !== undefined) newStyles.top = top;
  if (right !== undefined) newStyles.right = right;
  if (bottom !== undefined) newStyles.bottom = bottom;
  if (left !== undefined) newStyles.left = left;

  return _extends({ style: _extends({}, newStyles, style) }, props);
};
exports.parseProps = parseProps;