'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  padding: _propTypes2.default.number,
  paddingTop: _propTypes2.default.number,
  paddingRight: _propTypes2.default.number,
  paddingBottom: _propTypes2.default.number,
  paddingLeft: _propTypes2.default.number,
  paddingX: _propTypes2.default.number,
  paddingY: _propTypes2.default.number,
  margin: _propTypes2.default.number,
  marginTop: _propTypes2.default.number,
  marginRight: _propTypes2.default.number,
  marginBottom: _propTypes2.default.number,
  marginLeft: _propTypes2.default.number,
  marginX: _propTypes2.default.number,
  marginY: _propTypes2.default.number
};

var parseStyleProps = function parseStyleProps(_ref) {
  var all = _ref.all,
      top = _ref.top,
      right = _ref.right,
      bottom = _ref.bottom,
      left = _ref.left;

  var pAll = all || 0;
  return (top || pAll) + ' ' + (right || pAll) + ' ' + (bottom || pAll) + ' ' + (left || pAll);
};

var parseProps = function parseProps(_ref2) {
  var padding = _ref2.padding,
      paddingTop = _ref2.paddingTop,
      paddingRight = _ref2.paddingRight,
      paddingBottom = _ref2.paddingBottom,
      paddingLeft = _ref2.paddingLeft,
      paddingX = _ref2.paddingX,
      paddingY = _ref2.paddingY,
      margin = _ref2.margin,
      marginTop = _ref2.marginTop,
      marginRight = _ref2.marginRight,
      marginBottom = _ref2.marginBottom,
      marginLeft = _ref2.marginLeft,
      marginX = _ref2.marginX,
      marginY = _ref2.marginY,
      style = _ref2.style,
      props = _objectWithoutProperties(_ref2, ['padding', 'paddingTop', 'paddingRight', 'paddingBottom', 'paddingLeft', 'paddingX', 'paddingY', 'margin', 'marginTop', 'marginRight', 'marginBottom', 'marginLeft', 'marginX', 'marginY', 'style']);

  var styles = {};

  if (padding !== undefined || paddingTop !== undefined || paddingRight !== undefined || paddingBottom !== undefined || paddingLeft !== undefined || paddingX !== undefined || paddingY !== undefined) {
    styles.padding = parseStyleProps({
      all: padding,
      top: paddingTop !== undefined ? paddingTop : paddingY,
      right: paddingRight !== undefined ? paddingRight : paddingX,
      bottom: paddingBottom !== undefined ? paddingBottom : paddingY,
      left: paddingLeft !== undefined ? paddingLeft : paddingX
    });
  }

  if (margin !== undefined || marginTop !== undefined || marginRight !== undefined || marginBottom !== undefined || marginLeft !== undefined || marginX !== undefined || marginY !== undefined) {
    styles.margin = parseStyleProps({
      all: margin,
      top: marginTop !== undefined ? marginTop : marginY,
      right: marginRight !== undefined ? marginRight : marginX,
      bottom: marginBottom !== undefined ? marginBottom : marginY,
      left: marginLeft !== undefined ? marginLeft : marginX
    });
  }

  return _extends({ style: _extends({}, styles, style) }, props);
};
exports.parseProps = parseProps;