'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseProps = exports.propTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _glamor = require('glamor');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _theme = require('./../components/theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = exports.propTypes = {
  textStyle: _propTypes2.default.oneOf(Object.keys(_theme2.default.textStyles)),
  bold: _propTypes2.default.bool,
  textColor: _propTypes2.default.oneOf(Object.keys(_theme2.default.textColors))
};

var getTextStyle = function getTextStyle(_ref, textStyle) {
  var fontSize = _ref.fontSize,
      fontWeight = _ref.fontWeight,
      lineHeight = _ref.lineHeight,
      letterSpacing = _ref.letterSpacing,
      textTransform = _ref.textTransform,
      fontFamily = _ref.fontFamily,
      color = _ref.color;
  return {
    '&, & .ui-lib-box:not(.ui-lib-has-text-style)': _extends({}, fontSize ? { fontSize: fontSize } : {}, fontWeight ? { fontWeight: fontWeight } : {}, lineHeight ? { lineHeight: lineHeight } : {}, letterSpacing ? { letterSpacing: letterSpacing } : {}, textTransform ? { textTransform: textTransform } : {}, fontFamily ? { fontFamily: fontFamily } : {}, color ? { color: color } : {})
  };
};

var getClassName = function getClassName(_ref2) {
  var textStyle = _ref2.textStyle;
  return (0, _glamor.css)(_extends({}, textStyle ? getTextStyle(_theme2.default.textStyles[textStyle], textStyle) : {}));
};

var parseProps = function parseProps(_ref3) {
  var textStyle = _ref3.textStyle,
      textColor = _ref3.textColor,
      bold = _ref3.bold,
      className = _ref3.className,
      props = _objectWithoutProperties(_ref3, ['textStyle', 'textColor', 'bold', 'className']);

  if (textStyle !== undefined || bold !== undefined || textColor !== undefined) {
    return _extends({
      className: (0, _classnames2.default)('' + getClassName({ textStyle: textStyle, bold: bold }), bold && '' + (0, _glamor.css)({ fontWeight: '500' }), textColor && '' + (0, _glamor.css)({ color: _theme2.default.textColors[textColor] }), textStyle !== undefined && 'ui-lib-has-text-style', className)
    }, props);
  }
  return _extends({ className: className }, props);
};
exports.parseProps = parseProps;