'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buttonStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;
function buttonStory(module) {
  (0, _react3.storiesOf)('Button', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Button\n\nThe Button component. Implements `<Box />`.\n\n* Set `paddingX=\'0\'` if you are using icons\n\n```\n<Display4 display=\'inline-block\' marginRight={majorScale(1)} marginBottom={majorScale(1)}>Default</Display4>\n<Pane marginBottom={majorScale(2)}>\n  <Button paddingX=\'0\' marginRight={majorScale(1)}><CogIcon /></Button>\n  <Button marginRight={majorScale(1)}>Default Button</Button>\n  <Button primary marginRight={majorScale(1)}>Primary Button</Button>\n  <Button danger marginRight={majorScale(1)}>Danger Button</Button>\n  <Button disabled marginRight={majorScale(1)}>Disabled Button</Button>\n</Pane>\n\n<Display4 display=\'inline-block\' marginRight={majorScale(1)} marginBottom={majorScale(1)}>Small</Display4>\n<Pane>\n  <Button size=\'small\' paddingX=\'0\' marginRight={majorScale(1)}><CogIcon size=\'mini\' /></Button>\n  <Button size=\'small\' marginRight={majorScale(1)}>Default Button</Button>\n  <Button size=\'small\' primary marginRight={majorScale(1)}>Primary Button</Button>\n  <Button size=\'small\' danger marginRight={majorScale(1)}>Danger Button</Button>\n  <Button size=\'small\' disabled marginRight={majorScale(1)}>Disabled Button</Button>\n</Pane>\n```\n'
        ),
        _react2.default.createElement(
          _components.Display4,
          { display: 'inline-block', marginRight: majorScale(1), marginBottom: majorScale(1) },
          'Default'
        ),
        _react2.default.createElement(
          _components.Pane,
          { marginBottom: majorScale(2) },
          _react2.default.createElement(
            _components.Button,
            { paddingX: '0', marginRight: majorScale(1) },
            _react2.default.createElement(_components.CogIcon, null)
          ),
          _react2.default.createElement(
            _components.Button,
            { marginRight: majorScale(1) },
            'Default Button'
          ),
          _react2.default.createElement(
            _components.Button,
            { primary: true, marginRight: majorScale(1) },
            'Primary Button'
          ),
          _react2.default.createElement(
            _components.Button,
            { danger: true, marginRight: majorScale(1) },
            'Danger Button'
          ),
          _react2.default.createElement(
            _components.Button,
            { disabled: true, marginRight: majorScale(1) },
            'Disabled Button'
          )
        ),
        _react2.default.createElement(
          _components.Display4,
          { display: 'inline-block', marginRight: majorScale(1), marginBottom: majorScale(1) },
          'Small'
        ),
        _react2.default.createElement(
          _components.Pane,
          null,
          _react2.default.createElement(
            _components.Button,
            { size: 'small', paddingX: '0', marginRight: majorScale(1) },
            _react2.default.createElement(_components.CogIcon, { size: 'mini' })
          ),
          _react2.default.createElement(
            _components.Button,
            { size: 'small', marginRight: majorScale(1) },
            'Default Button'
          ),
          _react2.default.createElement(
            _components.Button,
            { size: 'small', primary: true, marginRight: majorScale(1) },
            'Primary Button'
          ),
          _react2.default.createElement(
            _components.Button,
            { size: 'small', danger: true, marginRight: majorScale(1) },
            'Danger Button'
          ),
          _react2.default.createElement(
            _components.Button,
            { size: 'small', disabled: true, marginRight: majorScale(1) },
            'Disabled Button'
          )
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | version | type | default | description\n-----|---------|------| --------|----------\n`size`| v3.0.0 | `small`, `default` | `default` | as defined by `theme.controlSizes`\n`secondary`| v1 | boolean | `true` | renders a secondary button, used by default\n`primary`| v1 | boolean | `undefined` | renders a green primary button\n`danger`| v1 | boolean | `undefined` | renders a pinkish button\n`disabled`| v7.2.0 | boolean | `undefined` | disables the `<button>` and renders it grey\n'
        )
      )
    );
  });
}