'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (module) {
  (0, _react3.storiesOf)('Corner Dialog', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# CornerDialog\n\nThe CornerDialog component. Implements `<Box />`.\n\n* Default width is `384px`\n\n```\nclass CornerDialogExample extends Component {\n  constructor () {\n    super()\n\n    this.state = {\n      isOpen: false\n    }\n\n    this.toggleCornerDialog = this.toggleCornerDialog.bind(this)\n  }\n\n  render () {\n    const {isOpen} = this.state\n\n    return (\n      <Pane display=\'flex\' flexDirection=\'column\' alignItems=\'center\'>\n        <Button primary onClick={this.toggleCornerDialog}>Open CornerDialog</Button>\n        <CornerDialog isOpen={isOpen} onClose={this.toggleCornerDialog} title=\'App Redesign\'>\n          <Body1>\n            Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.\n          </Body1>\n          <Button is=\'a\' href=\'#\' primary marginTop={majorScale(2)}>\n            Read blog post\n          </Button>\n        </CornerDialog>\n      </Pane>\n    )\n  }\n\n  toggleCornerDialog () {\n    this.setState((prevState) => ({isOpen: !prevState.isOpen}))\n  }\n}\n```\n'
        ),
        _react2.default.createElement(CornerDialogExample, null),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | version | type | default | description\n-----|---------|------| --------|----------\n`title`| v7.9.0 | `node` | `undefined` | title of the CornerDialog\n`isOpen`| v7.9.0 | `boolean` | `false` | whether the CornerDialog is open or not\n`children`| v7.9.0 | `node` | `undefined` | contents of the CornerDialog\n`onClose`| v7.9.0 | `function` | `undefined` | [optional] called when the close button or overlay is clicked\n'
        )
      )
    );
  });
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var majorScale = _components.theme.majorScale;

var CornerDialogExample = function (_Component) {
  _inherits(CornerDialogExample, _Component);

  function CornerDialogExample() {
    _classCallCheck(this, CornerDialogExample);

    var _this = _possibleConstructorReturn(this, (CornerDialogExample.__proto__ || Object.getPrototypeOf(CornerDialogExample)).call(this));

    _this.state = {
      isOpen: false
    };

    _this.toggleCornerDialog = _this.toggleCornerDialog.bind(_this);
    return _this;
  }

  _createClass(CornerDialogExample, [{
    key: 'render',
    value: function render() {
      var isOpen = this.state.isOpen;


      return _react2.default.createElement(
        _components.Pane,
        { display: 'flex', flexDirection: 'column', alignItems: 'center' },
        _react2.default.createElement(
          _components.Button,
          { primary: true, onClick: this.toggleCornerDialog },
          'Open CornerDialog'
        ),
        _react2.default.createElement(
          _components.CornerDialog,
          { isOpen: isOpen, onClose: this.toggleCornerDialog, title: 'App Redesign' },
          _react2.default.createElement(
            _components.Body1,
            null,
            'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore.'
          ),
          _react2.default.createElement(
            _components.Button,
            { is: 'a', href: '#', primary: true, marginTop: majorScale(2) },
            'Read blog post'
          )
        )
      );
    }
  }, {
    key: 'toggleCornerDialog',
    value: function toggleCornerDialog() {
      this.setState(function (prevState) {
        return { isOpen: !prevState.isOpen };
      });
    }
  }]);

  return CornerDialogExample;
}(_react.Component);