'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = layoutsStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;


var Label = function Label(props) {
  return _react2.default.createElement(_components.Text, _extends({ is: 'label', textStyle: 'display4', bold: true, display: 'block' }, props));
};

var AvatarWithTriangle = function AvatarWithTriangle() {
  return _react2.default.createElement(
    _components.Box,
    { display: 'inline-flex', alignItems: 'center' },
    _react2.default.createElement(
      _components.Avatar,
      { marginLeft: majorScale(1), marginRight: majorScale(1), src: '', imageSize: 'small' },
      'Segment Sloth'
    ),
    _react2.default.createElement(_components.Triangle, { aim: 'down', display: 'inline-flex', fill: 'white' })
  );
};

function layoutsStory(module) {
  (0, _react3.storiesOf)('Layouts', module).add('tabbed Nav + Sub Nav', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.NavigationBar,
        { left: 'Sloth Corp Media', right: _react2.default.createElement(AvatarWithTriangle, null) },
        _react2.default.createElement(
          _components.NavigationBarLink,
          { active: true },
          'Sources'
        ),
        _react2.default.createElement(
          _components.NavigationBarLink,
          { href: '#' },
          'Warehouses'
        )
      ),
      _react2.default.createElement(
        _components.SubNavigationBar,
        { left: 'Sources' },
        ['Overview', 'Integrations', 'Debugger', 'Schema', 'Settings'].map(function (name) {
          return _react2.default.createElement(
            _components.SubNavigationBarLink,
            { key: name, href: '#', active: name === 'Settings' },
            name
          );
        })
      ),
      _react2.default.createElement(
        _components.Pane,
        { flexAuto: true, display: 'flex' },
        _react2.default.createElement(
          _components.Sidebar,
          null,
          _react2.default.createElement(
            _components.SidebarLink,
            { key: 'Basic', href: '#', active: true },
            'Basic'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { key: 'Collaborators', href: '#' },
            'Collaborators'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { key: 'Settings', href: '#' },
            'SQL Settings'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { key: 'Schema', href: '#' },
            'Clear Schema'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { key: 'Workspace', href: '#' },
            'Transfer To Workspace'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { key: 'Keys', href: '#' },
            'API Keys'
          )
        ),
        _react2.default.createElement(
          _components.Pane,
          { display: 'flex', flexAuto: true, justifyContent: 'center' },
          _react2.default.createElement(
            _components.Pane,
            { width: '680px', margin: majorScale(6) },
            _react2.default.createElement(
              _components.Pane,
              { white: true, rounded: true, border: true, padding: majorScale(6) },
              _react2.default.createElement(
                _components.Text,
                { is: 'h2', textStyle: 'display2', marginBottom: majorScale(4) },
                'Basic Settings'
              ),
              _react2.default.createElement(
                Label,
                { htmlFor: 'Nickname' },
                'Nickname'
              ),
              _react2.default.createElement(_components.Input, { readOnly: true, id: 'Nickname', value: 'Slothzilla', name: 'Nickname', marginTop: majorScale(1), marginBottom: majorScale(1) }),
              _react2.default.createElement(
                _components.Text,
                { textStyle: 'body2' },
                'Pick a name to help you identify this source in Segment.'
              ),
              _react2.default.createElement(
                _components.Button,
                { primary: true, marginTop: majorScale(4) },
                'Save changes'
              ),
              _react2.default.createElement(
                _components.Pane,
                { white: true, borderTop: true, textStyle: 'body2', marginTop: majorScale(4), paddingTop: majorScale(4) },
                _react2.default.createElement(
                  _components.Link,
                  { underline: true, primary: true, href: '' },
                  'Delete this source.'
                ),
                ' No data will be deleted from your source.'
              )
            )
          )
        )
      )
    );
  });
}