'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = linkStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;
function linkStory(module) {
  (0, _react3.storiesOf)('Link', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Link\n\nThe Link component is a `a` or `span` element. Implement the `<Text />` component.\n\n```\n<Text textStyle=\'body1\'>\n  <Link underline href=\'\'>Primary Link by default</Link><br/>\n  <Link underline secondary href=\'\'>Secondary Link</Link><br/>\n  <Link underline danger href=\'\'>danger Link</Link><br/>\n  <Link underline={false} active href=\'\'>Active Link becomes a span</Link>\n</Text>\n<Text textStyle=\'display2\'>\n  <Link underline href=\'\'>Primary Link by default</Link><br/>\n</Text>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Text,
          { textStyle: 'body1' },
          _react2.default.createElement(
            _components.Link,
            { underline: true, href: '' },
            'Primary Link by default'
          ),
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            _components.Link,
            { underline: true, secondary: true, href: '' },
            'Secondary Link'
          ),
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            _components.Link,
            { underline: true, danger: true, href: '' },
            'danger Link'
          ),
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            _components.Link,
            { underline: false, active: true, href: '' },
            'Active Link becomes a span'
          )
        ),
        _react2.default.createElement(
          _components.Text,
          { textStyle: 'display2' },
          _react2.default.createElement(
            _components.Link,
            { underline: true, href: '' },
            'Primary Link by default'
          ),
          _react2.default.createElement('br', null)
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------|----------|-------------\n`underline` | boolean | true | text-decoration: underline;\n`primary` | boolean | true |primary intent styling\n`secondary` | boolean | undefined | secondary intent styling\n`danger` | boolean | undefined | danger intent styling\n`active` | boolean | undefined | becomes a span and gets active className\n'
        )
      )
    );
  });
}