'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = paginationStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;
function paginationStory(module) {
  (0, _react3.storiesOf)('Pagination', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Pagination\n\nThe Pagination component is used to provide pagination controls for use with large lists of content.\n\n```\n<Pagination\n  itemName={\'item\'}\n  pageSize={50}\n  onPageSizeChange={() => {}}\n  totalItemCount={100}\n  currentPageNum={0}\n  onCurrentPageNumChange={() => {}}\n  firstPageNum={0}\n  lastPageNum={100}\n/>\n```\n\n'
        ),
        _react2.default.createElement(_components.Pagination, {
          itemName: 'item',
          pageSize: 50,
          onPageSizeChange: function onPageSizeChange() {},
          totalItemCount: 100,
          currentPageNum: 0,
          onCurrentPageNumChange: function onCurrentPageNumChange() {},
          firstPageNum: 0,
          lastPageNum: 100
        }),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | description\n-----|------|-------------\n`itemName` | string | the name of the items in paginated list\n`pageSize` | int | the current number of items shown at once\n`onPageSizeChange` | func | callback when a new page size is selected\n`totalItemCount` | int | the total number of items in paginated list\n`currentPageNum` | int | the current page of pagination\n`onCurrentPageNumChange` | func | callback when a new page num is selected\n`firstPageNum` | int | the number that the pagination should start at\n`lastPageNum` | int | the number that the pagination should end at\n`hidePageSizeSelect` | boolean | whether or not the page size select should be hidden\n'
        )
      )
    );
  });
}