'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = radioStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var majorScale = _components.theme.majorScale;

var AdvancedExample = function (_React$Component) {
  _inherits(AdvancedExample, _React$Component);

  function AdvancedExample() {
    _classCallCheck(this, AdvancedExample);

    var _this = _possibleConstructorReturn(this, (AdvancedExample.__proto__ || Object.getPrototypeOf(AdvancedExample)).call(this));

    _this.state = {
      checkedParent: null,
      checkedChild: null,
      otherText: null
    };

    _this.onSelectParent = _this.onSelectParent.bind(_this);
    _this.onSelectChild = _this.onSelectChild.bind(_this);
    return _this;
  }

  _createClass(AdvancedExample, [{
    key: 'render',
    value: function render() {
      var _state = this.state,
          checkedParent = _state.checkedParent,
          checkedChild = _state.checkedChild;

      return _react2.default.createElement(
        'form',
        null,
        _react2.default.createElement(
          _components.Radio,
          { name: 'exampleParent', value: 'parentBasic', checked: checkedParent === 'parentBasic', onChange: this.onSelectParent },
          'Here is a basic example.'
        ),
        _react2.default.createElement(
          _components.Radio,
          { name: 'exampleParent', value: 'parentNested', checked: checkedParent === 'parentNested', onChange: this.onSelectParent },
          'Click me to see what nested radio looks like.'
        ),
        checkedParent === 'parentNested' && _react2.default.createElement(
          _components.Box,
          { marginLeft: majorScale(3) },
          _react2.default.createElement(
            _components.Radio,
            { name: 'exampleChild', value: 'childFirst', checked: checkedChild === 'childFirst', onChange: this.onSelectChild },
            'Here is a nested radio button.'
          ),
          _react2.default.createElement(
            _components.Radio,
            { name: 'exampleChild', value: 'childSecond', checked: checkedChild === 'childSecond', onChange: this.onSelectChild },
            'Nested radio buttons only show when their parent is selected.'
          ),
          _react2.default.createElement(
            _components.Radio,
            { name: 'exampleChild', value: 'childThird', checked: checkedChild === 'childThird', onChange: this.onSelectChild },
            'They should be hidden once the parent gets unselected.'
          ),
          _react2.default.createElement(
            _components.Radio,
            { name: 'exampleChild', value: 'childFourth', checked: checkedChild === 'childFourth', onChange: this.onSelectChild },
            'Here is a basic margin top example.'
          )
        ),
        _react2.default.createElement(
          _components.Radio,
          { name: 'exampleParent', value: 'parentLast', checked: checkedParent === 'parentLast', onChange: this.onSelectParent },
          'Here is one last radio button.'
        )
      );
    }
  }, {
    key: 'onSelectParent',
    value: function onSelectParent(e) {
      this.setState({
        checkedParent: e.target.value,
        checkedChild: null
      });
    }
  }, {
    key: 'onSelectChild',
    value: function onSelectChild(e) {
      this.setState({
        checkedChild: e.target.value
      });
    }
  }]);

  return AdvancedExample;
}(_react2.default.Component);

function radioStory(module) {
  (0, _react3.storiesOf)('Radio', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Radio\n\n**Available since v4.1.0**\n\nThe Radio component is an `input` element. Implement the `<Box />` component.\n\n```\n<Radio name=\'example\' value=\'basic\'>Here is a basic example.</Radio>\n<Radio name=\'example\' value=\'checked\' checked>Here is basic checked example.</Radio>\n<Radio name=\'example\' value=\'margin\' marginTop=\'25px\'>Here is a basic margin top example.</Radio>\n<Radio name=\'example\' value=\'disabled\' disabled>Here is a basic disabled state example.</Radio>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Radio,
          { name: 'example', value: 'basic' },
          'Here is a basic example.'
        ),
        _react2.default.createElement(
          _components.Radio,
          { name: 'example', value: 'checked', checked: true },
          'Here is basic checked example.'
        ),
        _react2.default.createElement(
          _components.Radio,
          { name: 'example', value: 'margin', marginTop: '25px' },
          'Here is a basic margin top example.'
        ),
        _react2.default.createElement(
          _components.Radio,
          { name: 'example', value: 'disabled', disabled: true },
          'Here is a basic disabled state example.'
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n\n# Advanced example\n\n```\nclass AdvancedExample extends React.Component {\n  constructor () {\n    super()\n\n    this.state = {\n      checkedParent: null,\n      checkedChild: null,\n      otherText: null\n    }\n\n    this.onSelectParent = this.onSelectParent.bind(this)\n    this.onSelectChild = this.onSelectChild.bind(this)\n  }\n\n  render () {\n    const { checkedParent, checkedChild } = this.state\n    return (\n      <form>\n        <Radio name=\'exampleParent\' value=\'parentBasic\' checked={checkedParent === \'parentBasic\'} onChange={this.onSelectParent}>Here is a basic example.</Radio>\n        <Radio name=\'exampleParent\' value=\'parentNested\' checked={checkedParent === \'parentNested\'} onChange={this.onSelectParent}>Click me to see what nested radio looks like.</Radio>\n        {checkedParent === \'parentNested\' &&\n          <Box marginLeft={majorScale(3)}>\n            <Radio name=\'exampleChild\' value=\'childFirst\' checked={checkedChild === \'childFirst\'} onChange={this.onSelectChild}>Here is a nested radio button.</Radio>\n            <Radio name=\'exampleChild\' value=\'childSecond\' checked={checkedChild === \'childSecond\'} onChange={this.onSelectChild}>Nested radio buttons only show when their parent is selected.</Radio>\n            <Radio name=\'exampleChild\' value=\'childThird\' checked={checkedChild === \'childThird\'} onChange={this.onSelectChild}>They should be hidden once the parent gets unselected.</Radio>\n            <Radio name=\'exampleChild\' value=\'childFourth\' checked={checkedChild === \'childFourth\'} onChange={this.onSelectChild}>Here is a basic margin top example.</Radio>\n          </Box>\n        }\n        <Radio name=\'exampleParent\' value=\'parentLast\' checked={checkedParent === \'parentLast\'} onChange={this.onSelectParent}>Here is one last radio button.</Radio>\n      </form>\n    )\n  }\n\n  onSelectParent (e) {\n    this.setState({\n      checkedParent: e.target.value,\n      checkedChild: null\n    })\n  }\n\n  onSelectChild (e) {\n    this.setState({\n      checkedChild: e.target.value\n    })\n  }\n}\n```\n\n'
        ),
        _react2.default.createElement(AdvancedExample, null)
      )
    );
  });
}