'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = sidebarStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;
function sidebarStory(module) {
  (0, _react3.storiesOf)('Sidebar', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      null,
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# Sidebar\n\nThe Sidebar component. Composes `<Pane />`.\nThe SidebarLink components. Composes `<Link />`.\n\n```\n<Sidebar>\n  <SidebarLink href=\'#\' active>Tracks</SidebarLink>\n  <SidebarLink href=\'#\'>Page</SidebarLink>\n  <SidebarLink href=\'#\'>Screen</SidebarLink>\n  <SidebarLink href=\'#\'>Identify</SidebarLink>\n  <SidebarLink href=\'#\'>Group</SidebarLink>\n</Sidebar>\n```\n\n'
        ),
        _react2.default.createElement(
          _components.Sidebar,
          null,
          _react2.default.createElement(
            _components.SidebarLink,
            { href: '#', active: true },
            'Tracks'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { href: '#' },
            'Page'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { href: '#' },
            'Screen'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { href: '#' },
            'Identify'
          ),
          _react2.default.createElement(
            _components.SidebarLink,
            { href: '#' },
            'Group'
          )
        ),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\nprop | type | default | description\n-----|------| --------|-------------\n`children` | node | undefined | contents of Sidebar\n'
        )
      )
    );
  }).add('with Sidebar Links', function () {
    return _react2.default.createElement(
      _components.Sidebar,
      { flexAuto: true },
      _react2.default.createElement(
        _components.SidebarLink,
        { href: '#', active: true },
        'Tracks'
      ),
      _react2.default.createElement(
        _components.SidebarLink,
        { href: '#' },
        'Page'
      ),
      _react2.default.createElement(
        _components.SidebarLink,
        { href: '#' },
        'Screen'
      ),
      _react2.default.createElement(
        _components.SidebarLink,
        { href: '#' },
        'Identify'
      ),
      _react2.default.createElement(
        _components.SidebarLink,
        { href: '#' },
        'Group'
      )
    );
  });
}