'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = inputStory;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _components = require('../components');

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var majorScale = _components.theme.majorScale;


var LoaderInput = (0, _components.withLoader)(_components.Input);
var LoaderInputStyled = (0, _components.withLoader)(_components.Input, {
  width: majorScale(8),
  height: majorScale(8),
  marginY: majorScale(4)
});

function inputStory(module) {
  (0, _react3.storiesOf)('withLoader', module).add('usage', function () {
    return _react2.default.createElement(
      _components.App,
      { white: true },
      _react2.default.createElement(
        _components.Pane,
        { white: true, padding: majorScale(10) },
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n# withLoader\n\nHigher Order Component for adding loading functionality to a component. Uses the `<Spinner />` component.\n\n```\nconst LoaderInput = withLoader(Input)\n<LoaderInput isLoading />\n```\n\n'
        ),
        _react2.default.createElement(LoaderInput, { isLoading: true }),
        _react2.default.createElement(
          _Content2.default,
          { markdown: true },
          '\n`withLoader(component, spinnerProps)`\n\nprop | type | default | description\n-----|------| --------|-------------\n`component` | function | undefined | Component constructor\n`spinnerProps` | object | `{ marginX: \'auto\', marginY: majorScale(8) }` | Custom styles for `<Spinner />` (merged with default)\n'
        )
      )
    );
  }).add('standalone', function () {
    return _react2.default.createElement(LoaderInput, { isLoading: true });
  }).add('with spinner props', function () {
    return _react2.default.createElement(LoaderInputStyled, { isLoading: true });
  });
}